# BalancerVault

[Git Source](https://github.com/Ion-Protocol/nucleus-boring-vault/blob/cc0b494b83e17b9b169a73b96050d2810b690477/src/interfaces/BalancerVault.sol)

## Functions

### flashLoan

```solidity
function flashLoan(address, address[] memory tokens, uint256[] memory amounts, bytes calldata userData) external;
```

### swap

```solidity
function swap(
    DecoderCustomTypes.SingleSwap memory singleSwap,
    DecoderCustomTypes.FundManagement memory funds,
    uint256 limit,
    uint256 deadline
)
    external
    returns (uint256 amountCalculated);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.nucleusearn.io/nucleus-architecture/smart-contracts/contracts/interfaces/balancervault.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
